diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -21,6 +21,7 @@ The Yum RPM software updater.
 import os
 import os.path
 import rpm
+import sys
 
 def _rpm_ver_atleast(vertup):
     """ Check if rpm is at least the current vertup. Can return False/True/None
@@ -44,10 +45,16 @@ import logging
 import logging.config
 import operator
 import tempfile
+import shutil
 
 import yum.i18n
-_ = yum.i18n._
-P_ = yum.i18n.P_
+# This is required to make gaftonmode work...
+_wrap_yum_i18n__ = yum.i18n._
+def _(*args, **kwargs):
+    return _wrap_yum_i18n__(*args, **kwargs)
+_wrap_yum_i18n_P_ = yum.i18n.P_
+def P_(*args, **kwargs):
+    return _wrap_yum_i18n_P_(*args, **kwargs)
 
 import config
 from config import ParsingError, ConfigParser
@@ -73,6 +80,9 @@ import logginglevels
 import yumRepo
 import callbacks
 import yum.history
+import yum.fssnapshots
+import yum.igroups
+import update_md
 
 import warnings
 warnings.simplefilter("ignore", Errors.YumFutureDeprecationWarning)
@@ -82,7 +92,8 @@ from packages import YumAvailablePackage, YumLocalPackage, YumInstalledPackage
 from packages import YumUrlPackage, YumNotFoundPackage
 from constants import *
 from yum.rpmtrans import RPMTransaction,SimpleCliCallBack
-from yum.i18n import to_unicode, to_str
+from yum.i18n import to_unicode, to_str, exception2msg
+from yum.drpm import DeltaInfo, DeltaPackage
 
 import string
 import StringIO
@@ -102,10 +113,12 @@ default_grabber.opts.user_agent += " yum/" + __version__
 
 
 class _YumPreBaseConf:
-    """This is the configuration interface for the YumBase configuration.
-       So if you want to change if plugins are on/off, or debuglevel/etc.
-       you tweak it here, and when yb.conf does it's thing ... it happens. """
-
+    """This is the configuration interface for the :class:`YumBase`
+    configuration.  To change configuration settings such as whether
+    plugins are on or off, or the value of debuglevel, change the
+    values here. Later, when :func:`YumBase.conf` is first called, all
+    of the options will be automatically configured.
+    """
     def __init__(self):
         self.fn = '/etc/yum/yum.conf'
         self.root = '/'
@@ -125,12 +138,15 @@ class _YumPreBaseConf:
 
 
 class _YumPreRepoConf:
-    """This is the configuration interface for the repos configuration.
-       So if you want to change callbacks etc. you tweak it here, and when
-       yb.repos does it's thing ... it happens. """
-
+    """This is the configuration interface for the repos configuration
+    configuration.  To change configuration settings such what
+    callbacks are used, change the values here. Later, when
+    :func:`YumBase.repos` is first called, all of the options will be
+    automatically configured.
+    """
     def __init__(self):
         self.progressbar = None
+        self.multi_progressbar = None
         self.callback = None
         self.failure_callback = None
         self.interrupt_callback = None
@@ -164,11 +180,11 @@ class _YumCostExclude:
         return False
 
 class YumBase(depsolve.Depsolve):
-    """This is a primary structure and base class. It houses the objects and
-       methods needed to perform most things in yum. It is almost an abstract
-       class in that you will need to add your own class above it for most
-       real use."""
-    
+    """This is a primary structure and base class. It houses the
+    objects and methods needed to perform most things in yum. It is
+    almost an abstract class in that you will need to add your own
+    class above it for most real use.
+    """
     def __init__(self):
         depsolve.Depsolve.__init__(self)
         self._conf = None
@@ -177,9 +193,12 @@ class YumBase(depsolve.Depsolve):
         self._up = None
         self._comps = None
         self._history = None
+        self._igroups = None
         self._pkgSack = None
         self._lockfile = None
         self._tags = None
+        self._upinfo = None
+        self._fssnap = None
         self._ts_save_file = None
         self.skipped_packages = []   # packages skip by the skip-broken code
         self._not_found_a = {}
@@ -204,6 +223,9 @@ class YumBase(depsolve.Depsolve):
 
         self.run_with_package_names = set()
         self._cleanup = []
+        self.exit_code = 0
+
+        self.updateinfo_filters = {}
 
     def __del__(self):
         self.close()
@@ -213,10 +235,15 @@ class YumBase(depsolve.Depsolve):
         for cb in self._cleanup: cb()
 
     def close(self):
+        """Close the history and repo objects."""
+
         # We don't want to create the object, so we test if it's been created
         if self._history is not None:
             self.history.close()
 
+        if self._igroups is not None:
+            self.igroups.close()
+
         if self._repos:
             self._repos.close()
 
@@ -225,15 +252,33 @@ class YumBase(depsolve.Depsolve):
         return transactioninfo.TransactionData()
 
     def doGenericSetup(self, cache=0):
-        """do a default setup for all the normal/necessary yum components,
-           really just a shorthand for testing"""
+        """Do a default setup for all the normal or necessary yum
+        components.  This function is really just a shorthand for
+        testing purposes.
 
+        :param cache: whether to run in cache only mode, which will
+           run only from the system cache
+        """
         self.preconf.init_plugins = False
         self.conf.cache = cache
 
     def doConfigSetup(self, fn='/etc/yum/yum.conf', root='/', init_plugins=True,
             plugin_types=(plugins.TYPE_CORE,), optparser=None, debuglevel=None,
             errorlevel=None):
+        """Deprecated.  Perform configuration setup.
+
+        :param fn: the name of the configuration file to use
+        :param root: the root directory to use
+        :param init_plugins: whether to initialize plugins before
+           running yum
+        :param plugin_types: a tuple containing the types to plugins
+           to load
+        :param optparser: the option parser to use for configuration
+        :param debuglevel: the minimum debug logging level to output
+           messages from
+        :param errorlevel: the minimum error logging level to output
+           messages from
+        """
         warnings.warn(_('doConfigSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -297,15 +342,17 @@ class YumBase(depsolve.Depsolve):
             # Try the old default
             fn = '/etc/yum.conf'
 
-        startupconf = config.readStartupConfig(fn, root)
+        startupconf = config.readStartupConfig(fn, root, releasever)
         startupconf.arch = arch
         startupconf.basearch = self.arch.basearch
         if uuid:
             startupconf.uuid = uuid
         
         if startupconf.gaftonmode:
-            global _
-            _ = yum.i18n.dummy_wrapper
+            global _wrap_yum_i18n__
+            _wrap_yum_i18n__ = yum.i18n.dummy_wrapper
+            global _wrap_yum_i18n_P_
+            _wrap_yum_i18n_P_ = yum.i18n.dummyP_wrapper
 
         if debuglevel != None:
             startupconf.debuglevel = debuglevel
@@ -336,6 +383,12 @@ class YumBase(depsolve.Depsolve):
 
         self._conf = config.readMainConfig(startupconf)
 
+        # update urlgrabber defaults
+        mc = self._conf.max_connections
+        if mc > 0:
+            default_grabber.opts.max_connections = mc
+        default_grabber.opts.timedhosts = self._conf.cachedir + '/timedhosts'
+
         #  We don't want people accessing/altering preconf after it becomes
         # worthless. So we delete it, and thus. it'll raise AttributeError
         del self.preconf
@@ -367,22 +420,36 @@ class YumBase(depsolve.Depsolve):
     def doLoggingSetup(self, debuglevel, errorlevel,
                        syslog_ident=None, syslog_facility=None,
                        syslog_device='/dev/log'):
-        '''
-        Perform logging related setup.
-
-        @param debuglevel: Debug logging level to use.
-        @param errorlevel: Error logging level to use.
-        '''
+        """Perform logging related setup.
+
+        :param debuglevel: the minimum debug logging level to output
+           messages from
+        :param errorlevel: the minimum error logging level to output
+           messages from
+        :param syslog_ident: the ident of the syslog to use
+        :param syslog_facility: the name of the syslog facility to use
+        :param syslog_device: the syslog device to use
+        """
         logginglevels.doLoggingSetup(debuglevel, errorlevel,
                                      syslog_ident, syslog_facility,
                                      syslog_device)
 
     def doFileLogSetup(self, uid, logfile):
+        """Set up the logging file.
+
+        :param uid: the user id of the current user
+        :param logfile: the name of the file to use for logging
+        """
         logginglevels.setFileLog(uid, logfile, self._cleanup)
 
     def getReposFromConfigFile(self, repofn, repo_age=None, validate=None):
-        """read in repositories from a config .repo file"""
+        """Read in repositories from a config .repo file.
 
+        :param repofn: a string specifying the path of the .repo file
+           to read
+        :param repo_age: the last time that the .repo file was
+           modified, in seconds since the epoch
+        """
         if repo_age is None:
             repo_age = os.stat(repofn)[8]
         
@@ -391,8 +458,7 @@ class YumBase(depsolve.Depsolve):
         try:
             parser.readfp(confpp_obj)
         except ParsingError, e:
-            msg = str(e)
-            raise Errors.ConfigError, msg
+            raise Errors.ConfigError(exception2msg(e))
 
         # Check sections in the .repo file that was just slurped up
         for section in parser.sections():
@@ -429,17 +495,41 @@ class YumBase(depsolve.Depsolve):
 
                 thisrepo.base_persistdir = self.conf._repos_persistdir
 
+            # do the wildcard ones first
+            # The keys are in indeterminate order at this point, *sigh*.
+            for i in sorted(self.repo_setopts):
+                #  Skip normal names, as we want to do wildcard matches first
+                # and then override with specific id stuff.
+                if not misc.re_glob(i):
+                    continue
 
+                if fnmatch.fnmatch(thisrepo.id, i):
+                    for opt in self.repo_setopts[i].items:
+                        self._checkOption(opt, thisrepo)
+                        setattr(thisrepo, opt, getattr(self.repo_setopts[i], opt))
+                
             if thisrepo.id in self.repo_setopts:
                 for opt in self.repo_setopts[thisrepo.id].items:
-                    if not hasattr(thisrepo, opt):
-                        msg = "Repo %s did not have a %s attr. before setopt"
-                        self.logger.warning(msg % (thisrepo.id, opt))
+                    self._checkOption(opt, thisrepo)
                     setattr(thisrepo, opt, getattr(self.repo_setopts[thisrepo.id], opt))
                     
             if validate and not validate(thisrepo):
                 continue
                     
+            if thisrepo.ssl_check_cert_permissions:
+                for fn in  (thisrepo.sslcacert,
+                            thisrepo.sslclientcert, thisrepo.sslclientkey):
+                    if not fn:
+                        continue
+                    #  If we can't read the SSL certs. we need to skip the repo.
+                    # if we don't have all the data.
+                    if not os.access(fn, os.R_OK):
+                        msg="Repo %s forced skip_if_unavailable=True due to: %s"
+                        if thisrepo.enabled:
+                            # Don't spam messages for disabled repos.
+                            self.logger.warning(msg % (thisrepo.id, fn))
+                        thisrepo.skip_if_unavailable = True
+
             # Got our list of repo objects, add them to the repos
             # collection
             try:
@@ -447,9 +537,18 @@ class YumBase(depsolve.Depsolve):
             except Errors.RepoError, e:
                 self.logger.warning(e)
         
-    def getReposFromConfig(self):
-        """read in repositories from config main and .repo files"""
+    def _checkOption(self, opt, thisrepo):
+        """Quit if the option is invalid"""
+        if not hasattr(thisrepo, opt):
+            msg = "Invalid option: %s"
+            raise Errors.ConfigError(msg % opt)
 
+    def getReposFromConfig(self):
+        """Read in repositories from the main yum conf file, and from
+        .repo files.  The location of the main yum conf file is given
+        by self.conf.config_file_path, and the location of the
+        directory of .repo files is given by self.conf.reposdir.
+        """
         # Read .repo files from directories specified by the reposdir option
         # (typically /etc/yum/repos.d)
         repo_config_age = self.conf.config_file_age
@@ -463,21 +562,26 @@ class YumBase(depsolve.Depsolve):
             # if we don't do this then anaconda likes to not  work.
             if os.path.exists(self.conf.installroot+'/'+reposdir):
                 reposdir = self.conf.installroot + '/' + reposdir
+            reposdir = os.path.normpath(reposdir)
 
             if os.path.isdir(reposdir):
                 for repofn in sorted(glob.glob('%s/*.repo' % reposdir)):
+                    if not os.access(repofn, os.R_OK):
+                        self.logger.warning(_("Skipping unreadable repository %s"), repr(repofn))
+                        continue
                     thisrepo_age = os.stat(repofn)[8]
                     if thisrepo_age < repo_config_age:
                         thisrepo_age = repo_config_age
                     self.getReposFromConfigFile(repofn, repo_age=thisrepo_age)
 
     def readRepoConfig(self, parser, section):
-        '''Parse an INI file section for a repository.
+        """Parse an INI file section for a repository.
 
-        @param parser: ConfParser or similar to read INI file values from.
-        @param section: INI file section to read.
-        @return: YumRepository instance.
-        '''
+        :param parser: :class:`ConfigParser` or similar object to read
+           INI file values from
+        :param section: INI file section to read
+        :return: :class:`yum.yumRepo.YumRepository` instance
+        """
         repo = yumRepo.YumRepository(section)
         try:
             repo.populate(parser, section, self.conf)
@@ -493,38 +597,40 @@ class YumBase(depsolve.Depsolve):
         repo.name = to_unicode(repo.name)
 
         # Set attributes not from the config file
+        repo.old_base_cache_dir = getattr(self, '_old_cachedir', '')
         repo.basecachedir = self.conf.cachedir
         repo.yumvar.update(self.conf.yumvar)
         repo.cfg = parser
-
+        # Enable parallel downloading
+        repo._async = repo.async
         return repo
 
     def disablePlugins(self):
-        '''Disable yum plugins
-        '''
+        """Disable yum plugins."""
+
         self.plugins = plugins.DummyYumPlugins()
     
     def doPluginSetup(self, optparser=None, plugin_types=None, searchpath=None,
             confpath=None,disabled_plugins=None,enabled_plugins=None):
-        '''Initialise and enable yum plugins. 
-
-        Note: _getConfig() will initialise plugins if instructed to. Only
-        call this method directly if not calling _getConfig() or calling
-        doConfigSetup(init_plugins=False).
-
-        @param optparser: The OptionParser instance for this run (optional)
-        @param plugin_types: A sequence specifying the types of plugins to load.
-            This should be a sequence containing one or more of the
-            yum.plugins.TYPE_...  constants. If None (the default), all plugins
-            will be loaded.
-        @param searchpath: A list of directories to look in for plugins. A
-            default will be used if no value is specified.
-        @param confpath: A list of directories to look in for plugin
-            configuration files. A default will be used if no value is
-            specified.
-        @param disabled_plugins: Plugins to be disabled    
-        @param enabled_plugins: Plugins to be enabled
-        '''
+        """Initialise and enable yum plugins.
+        Note: _getConfig() will also initialise plugins if instructed
+        to. Only call this method directly if not calling _getConfig()
+        or calling doConfigSetup(init_plugins=False).
+
+        :param optparser: the :class:`OptionParser` instance to use
+           for this run
+        :param plugin_types: a sequence specifying the types of plugins to load.
+           This should be a sequence containing one or more of the
+           yum.plugins.TYPE_...  constants. If None (the default), all plugins
+           will be loaded
+        :param searchpath: a list of directories to look in for plugins. A
+           default will be used if no value is specified
+        :param confpath: a list of directories to look in for plugin
+           configuration files. A default will be used if no value is
+           specified
+        :param disabled_plugins: a list of plugins to be disabled    
+        :param enabled_plugins: a list plugins to be enabled
+        """
         if isinstance(self.plugins, plugins.YumPlugins):
             raise RuntimeError(_("plugins already initialised"))
 
@@ -533,6 +639,8 @@ class YumBase(depsolve.Depsolve):
 
     
     def doRpmDBSetup(self):
+        """Deprecated.  Set up the rpm database."""
+
         warnings.warn(_('doRpmDBSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -552,7 +660,8 @@ class YumBase(depsolve.Depsolve):
         return self._rpmdb
 
     def closeRpmDB(self):
-        """closes down the instances of the rpmdb we have wangling around"""
+        """Closes down the instances of rpmdb that could be open."""
+
         if self._rpmdb is not None:
             self._rpmdb.ts = None
             self._rpmdb.dropCachedData()
@@ -561,12 +670,19 @@ class YumBase(depsolve.Depsolve):
         self._tsInfo = None
         self._up = None
         self.comps = None
+        self.igroups = None
     
     def _deleteTs(self):
         del self._ts
         self._ts = None
 
     def doRepoSetup(self, thisrepo=None):
+        """Deprecated. Set up the yum repositories.
+
+        :param thisrepo: the repository to set up.  If None, all
+           repositories will be set up
+        :return: the set up repos
+        """
         warnings.warn(_('doRepoSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -577,6 +693,12 @@ class YumBase(depsolve.Depsolve):
         if hasattr(self, 'prerepoconf'):
             self.conf # touch the config class first
 
+            if (self.conf.installroot != '/' and
+                not hasattr(self, '_old_cachedir')):
+                # Try loading cache from outside...
+                ir = len(self.conf.installroot)
+                self._old_cachedir = self.conf.cachedir[ir:]
+
             self.getReposFromConfig()
 
         #  For rhnplugin, and in theory other stuff, calling
@@ -588,7 +710,8 @@ class YumBase(depsolve.Depsolve):
             prerepoconf = self.prerepoconf
             del self.prerepoconf
 
-            self.repos.setProgressBar(prerepoconf.progressbar)
+            self.repos.setProgressBar(prerepoconf.progressbar,
+                                      prerepoconf.multi_progressbar)
             self.repos.callback = prerepoconf.callback
             self.repos.setFailureCallback(prerepoconf.failure_callback)
             self.repos.setInterruptCallback(prerepoconf.interrupt_callback)
@@ -602,24 +725,6 @@ class YumBase(depsolve.Depsolve):
 
 
         if doSetup:
-            if (hasattr(urlgrabber, 'grabber') and
-                hasattr(urlgrabber.grabber, 'pycurl')):
-                # Must do basename checking, on cert. files...
-                cert_basenames = {}
-                for repo in self._repos.listEnabled():
-                    if not repo.sslclientcert:
-                        continue
-                    bn = os.path.basename(repo.sslclientcert)
-                    if bn not in cert_basenames:
-                        cert_basenames[bn] = repo
-                        continue
-                    if repo.sslclientcert == cert_basenames[bn].sslclientcert:
-                        # Exactly the same path is fine too
-                        continue
-
-                    msg = 'sslclientcert basename shared between %s and %s'
-                    raise Errors.ConfigError, msg % (repo, cert_basenames[bn])
-
             repo_st = time.time()        
             self._repos.doSetup(thisrepo)
             self.verbose_logger.debug('repo time: %0.3f' % (time.time() - repo_st))        
@@ -630,6 +735,14 @@ class YumBase(depsolve.Depsolve):
         self._repos = RepoStorage(self)
     
     def doSackSetup(self, archlist=None, thisrepo=None):
+        """Deprecated. Populate the package sacks with information
+        from our repositories.
+
+        :param archlist: a list of the names of archs to include.  If
+           None, all arches are set up
+        :param thisrepo: the repository to use.  If None, all enabled
+           repositories are used
+        """
         warnings.warn(_('doSackSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -711,6 +824,9 @@ class YumBase(depsolve.Depsolve):
             
            
     def doUpdateSetup(self):
+        """Deprecated. Set up the update object in the base class and populate the
+        updates, obsoletes, and other lists.
+        """
         warnings.warn(_('doUpdateSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -765,6 +881,8 @@ class YumBase(depsolve.Depsolve):
         return self._up
     
     def doGroupSetup(self):
+        """Deprecated. Create and populate the groups object."""
+
         warnings.warn(_('doGroupSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
 
@@ -776,7 +894,12 @@ class YumBase(depsolve.Depsolve):
             # if we unset the comps object, we need to undo which repos have
             # been added to the group file as well
             if self._repos:
-                for repo in self._repos.listGroupsEnabled():
+                #  Used to do listGroupsEnabled(), which seems fine but requires
+                # calling .listEnalbed() ... which doesn't work on __del__ path
+                # if we haven't already called that (due to
+                # "prelistenabledrepos" plugins). So just blank it for
+                # all repos.
+                for repo in self._repos.sort():
                     repo.groups_added = False
         self._comps = val
     
@@ -801,7 +924,8 @@ class YumBase(depsolve.Depsolve):
                 continue
                 
             if not repo.ready():
-                raise Errors.RepoError, "Repository '%s' not yet setup" % repo
+                raise Errors.RepoError("Repository '%s' not yet setup" % repo,
+                                       repo=repo)
             try:
                 groupremote = repo.getGroupLocation()
             except Errors.RepoMDError, e:
@@ -813,6 +937,21 @@ class YumBase(depsolve.Depsolve):
         overwrite = self.conf.overwrite_groups
         self._comps = comps.Comps(overwrite_groups = overwrite)
 
+        if self.conf.group_command == 'objects':
+            #  Add the ids for installed groups/envs as though sys is a repo.
+            # makes everything easier (comps.return_groups() etc. works)...
+            self._comps.compscount += 1
+            for gid in self.igroups.groups:
+                grp = comps.Group()
+                grp.name = grp.groupid = gid
+                grp._weak = True
+                self._comps.add_group(grp)
+            for evgid in self.igroups.environments:
+                env = comps.Environment()
+                env.name = env.environmentid = evgid
+                env._weak = True
+                self._comps.add_environment(env)
+
         for repo in reposWithGroups:
             if repo.groups_added: # already added the groups from this repo
                 continue
@@ -820,16 +959,14 @@ class YumBase(depsolve.Depsolve):
             self.verbose_logger.log(logginglevels.DEBUG_4,
                 _('Adding group file from repository: %s'), repo)
             groupfile = repo.getGroups()
-            # open it up as a file object so iterparse can cope with our compressed file
-            if groupfile:
-                groupfile = misc.repo_gen_decompress(groupfile, 'groups.xml',
-                                                     cached=repo.cache)
-                # Do we want a RepoError here?
-                
+            if not groupfile:
+                msg = _('Failed to retrieve group file for repository: %s') % repo
+                self.logger.critical(msg)
+                continue
             try:
                 self._comps.add(groupfile)
             except (Errors.GroupsError,Errors.CompsException), e:
-                msg = _('Failed to add groups file for repository: %s - %s') % (repo, str(e))
+                msg = _('Failed to add groups file for repository: %s - %s') % (repo, exception2msg(e))
                 self.logger.critical(msg)
             else:
                 repo.groups_added = True
@@ -837,7 +974,10 @@ class YumBase(depsolve.Depsolve):
         if self._comps.compscount == 0:
             raise Errors.GroupsError, _('No Groups Available in any repository')
 
-        self._comps.compile(self.rpmdb.simplePkgList())
+        #  Note that this means that grp.installed is not usable, when using
+        # groups as objects ... but that's GOOD.
+        if self.conf.group_command != 'objects':
+            self._comps.compile(self.rpmdb.simplePkgList())
         self.verbose_logger.debug('group time: %0.3f' % (time.time() - group_st))                
         return self._comps
 
@@ -868,22 +1008,72 @@ class YumBase(depsolve.Depsolve):
                     # feed it into _tags.add()
                     self._tags.add(repo.id, tag_sqlite)
                 except (Errors.RepoError, Errors.PkgTagsError), e:
-                    msg = _('Failed to add Pkg Tags for repository: %s - %s') % (repo, str(e))
+                    msg = _('Failed to add Pkg Tags for repository: %s - %s') % (repo, exception2msg(e))
                     self.logger.critical(msg)
                     
                 
         self.verbose_logger.debug('tags time: %0.3f' % (time.time() - tag_st))
         return self._tags
         
+
+    def _getUpdateinfo(self):
+        """ create the Update Info object used to search/report the updateinfo
+            metadata"""
+
+        upi_st = time.time()
+        self.verbose_logger.log(logginglevels.DEBUG_4,
+                                _('Getting updateinfo metadata'))
+
+        if self._upinfo is None:
+            logger = logging.getLogger("yum.update_md")
+            vlogger = logging.getLogger("yum.verbose.update_md")
+            self._upinfo = update_md.UpdateMetadata(logger=logger,
+                                                    vlogger=vlogger)
+
+            for repo in self.repos.listEnabled():
+                if 'updateinfo' not in repo.repoXML.fileTypes():
+                    continue
+
+                self.verbose_logger.log(logginglevels.DEBUG_4,
+                    _('Adding Update Info from repository: %s'), repo)
+
+                try:
+                    self._upinfo.add(repo)
+                except Errors.RepoMDError, e:
+                    msg = _('Failed to add Update Info for repository: %s - %s') % (repo, exception2msg(e))
+                    self.logger.critical(msg)
+
+        self.verbose_logger.debug('updateinfo time: %0.3f' %
+                                  (time.time() - upi_st))
+        return self._upinfo
+
     def _getHistory(self):
         """auto create the history object that to access/append the transaction
            history information. """
         if self._history is None:
             pdb_path = self.conf.persistdir + "/history"
             self._history = yum.history.YumHistory(root=self.conf.installroot,
-                                                   db_path=pdb_path)
+                                                   db_path=pdb_path,
+                                                   releasever=self.conf.yumvar['releasever'])
         return self._history
     
+    def _getFSsnap(self):
+        """ create the fssnap object used to query/create snapshots. """
+        if self._fssnap is None:
+            devices = self.conf.fssnap_devices
+            self._fssnap = yum.fssnapshots._FSSnap(root=self.conf.installroot,
+                                                   devices=devices)
+
+        return self._fssnap
+
+    def _getIGroups(self):
+        """auto create the installed groups object that to access/change the
+           installed groups information. """
+        if self._igroups is None:
+            pdb_path = self.conf.persistdir + "/groups"
+            self._igroups = yum.igroups.InstalledGroups(db_path=pdb_path)
+        return self._igroups
+
     # properties so they auto-create themselves with defaults
     repos = property(fget=lambda self: self._getRepos(),
                      fset=lambda self, value: setattr(self, "_repos", value),
@@ -921,16 +1111,31 @@ class YumBase(depsolve.Depsolve):
                        fdel=lambda self: setattr(self, "_history", None),
                        doc="Yum History Object")
 
+    igroups = property(fget=lambda self: self._getIGroups(),
+                       fset=lambda self, value: setattr(self, "_igroups",value),
+                       fdel=lambda self: setattr(self, "_igroups", None),
+                       doc="Yum Installed Groups Object")
+
     pkgtags = property(fget=lambda self: self._getTags(),
                        fset=lambda self, value: setattr(self, "_tags",value),
                        fdel=lambda self: setattr(self, "_tags", None),
                        doc="Yum Package Tags Object")
-    
+
+    upinfo = property(fget=lambda self: self._getUpdateinfo(),
+                      fset=lambda self, value: setattr(self, "_upinfo", value),
+                      fdel=lambda self: setattr(self, "_upinfo", None),
+                      doc="Yum Update Info Object")
+
+    fssnap = property(fget=lambda self: self._getFSsnap(),
+                      fset=lambda self, value: setattr(self, "_fssnap",value),
+                      fdel=lambda self: setattr(self, "_fssnap", None),
+                      doc="Yum FS snapshot Object")
     
     def doSackFilelistPopulate(self):
-        """convenience function to populate the repos with the filelist metadata
-           it also is simply to only emit a log if anything actually gets populated"""
-        
+        """Convenience function to populate the repositories with the
+        filelist metadata, and emit a log message only if new
+        information is actually populated.
+        """
         necessary = False
         
         # I can't think of a nice way of doing this, we have to have the sack here
